var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.default=exports.PIPES=exports.checkAndCreateGitignore=exports.checkAndCreateProjectPackage=exports.copyRuntimeAssets=void 0;var _extends2=_interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _path=_interopRequireDefault(require("path"));
var _fs=_interopRequireDefault(require("fs"));
var _chalk=_interopRequireDefault(require("chalk"));
var _common=require("../common");












var _constants=require("../constants");


















var _apple=require("../platformTools/apple");
var _android=require("../platformTools/android");
var _tizen=require("../platformTools/tizen");
var _webos=require("../platformTools/webos");
var _electron=require("../platformTools/electron");
var _firefox=require("../platformTools/firefox");
var _web=require("../platformTools/web");
var _templateTools=require("../templateTools");
var _fileutils=require("../systemTools/fileutils");
var _platform=_interopRequireDefault(require("./platform"));
var _buildHooks=require("../projectTools/buildHooks");
var _logger=require("../systemTools/logger");

var CONFIGURE='configure';
var CREATE='create';
var NEW='new';

var PIPES={
APP_CONFIGURE_BEFORE:'app:configure:before',
APP_CONFIGURE_AFTER:'app:configure:after'};exports.PIPES=PIPES;


var highlight=_chalk.default.green;





var run=function run(c){
(0,_common.logTask)('run');

switch(c.command){
case NEW:
return _runCreate(c);}


switch(c.subCommand){
case CONFIGURE:
return _runConfigure(c);
case CREATE:
return _runCreate(c);













default:
return Promise.reject("Sub-Command "+c.subCommand+" not supported");}

};





var _runConfigure=function _runConfigure(c){return new Promise(function(resolve,reject){
var p=c.program.platform||'all';
(0,_common.logTask)("_runConfigure:"+p);

(0,_buildHooks.executePipe)(c,PIPES.APP_CONFIGURE_BEFORE).
then(function(){return _checkAndCreatePlatforms(c,c.program.platform);}).
then(function(){return copyRuntimeAssets(c);}).
then(function(){return _copySharedPlatforms(c);}).
then(function(){return _runPlugins(c,c.paths.rnvPluginsFolder);}).
then(function(){return _runPlugins(c,c.paths.projectPluginsFolder);}).
then(function(){return _isOK(c,p,[_constants.ANDROID])?(0,_android.configureGradleProject)(c,_constants.ANDROID):Promise.resolve();}).
then(function(){return _isOK(c,p,[_constants.ANDROID_TV])?(0,_android.configureGradleProject)(c,_constants.ANDROID_TV):Promise.resolve();}).
then(function(){return _isOK(c,p,[_constants.ANDROID_WEAR])?(0,_android.configureGradleProject)(c,_constants.ANDROID_WEAR):Promise.resolve();}).
then(function(){return _isOK(c,p,[_constants.TIZEN])?(0,_tizen.configureTizenGlobal)(c,_constants.TIZEN):Promise.resolve();}).
then(function(){return _isOK(c,p,[_constants.TIZEN])?(0,_tizen.configureTizenProject)(c,_constants.TIZEN):Promise.resolve();}).
then(function(){return _isOK(c,p,[_constants.TIZEN_WATCH])?(0,_tizen.configureTizenProject)(c,_constants.TIZEN_WATCH):Promise.resolve();}).
then(function(){return _isOK(c,p,[_constants.TIZEN_MOBILE])?(0,_tizen.configureTizenProject)(c,_constants.TIZEN_MOBILE):Promise.resolve();}).
then(function(){return _isOK(c,p,[_constants.WEBOS])?(0,_webos.configureWebOSProject)(c,_constants.WEBOS):Promise.resolve();}).
then(function(){return _isOK(c,p,[_constants.WEB])?(0,_web.configureWebProject)(c,_constants.WEB):Promise.resolve();}).
then(function(){return _isOK(c,p,[_constants.MACOS])?(0,_electron.configureElectronProject)(c,_constants.MACOS):Promise.resolve();}).
then(function(){return _isOK(c,p,[_constants.WINDOWS])?(0,_electron.configureElectronProject)(c,_constants.WINDOWS):Promise.resolve();}).
then(function(){return _isOK(c,p,[_constants.KAIOS])?(0,_firefox.configureKaiOSProject)(c,_constants.KAIOS):Promise.resolve();}).
then(function(){return _isOK(c,p,[_constants.FIREFOX_OS])?(0,_firefox.configureKaiOSProject)(c,_constants.FIREFOX_OS):Promise.resolve();}).
then(function(){return _isOK(c,p,[_constants.FIREFOX_TV])?(0,_firefox.configureKaiOSProject)(c,_constants.FIREFOX_TV):Promise.resolve();}).
then(function(){return _isOK(c,p,[_constants.IOS])?(0,_apple.configureXcodeProject)(c,_constants.IOS):Promise.resolve();}).
then(function(){return _isOK(c,p,[_constants.TVOS])?(0,_apple.configureXcodeProject)(c,_constants.TVOS):Promise.resolve();}).
then(function(){return(0,_buildHooks.executePipe)(c,PIPES.APP_CONFIGURE_AFTER);}).
then(function(){return resolve();}).
catch(function(e){return reject(e);});
});};

var _isOK=function _isOK(c,p,list){
var result=false;
list.forEach(function(v){
if((0,_common.isPlatformActive)(c,v)&&(p===v||p==='all'))result=true;
});
return result;
};

var _runCreate=function _runCreate(c){return new Promise(function(resolve,reject){
(0,_common.logTask)('_runCreate');

var data={
defaultVersion:'0.1.0',
defaultTemplate:'renative-template-hello-world',
defaultProjectName:'helloRenative',
defaultAppTitle:'Hello Renative'};

data.optionPlatforms=(0,_common.generateOptions)(_common.SUPPORTED_PLATFORMS,true);
data.optionTemplates=(0,_templateTools.getTemplateOptions)();



(0,_common.askQuestion)("What's your project Name? (no spaces, folder based on ID will be created in this directory)",data,'inputProjectName').
then(function(){return(0,_common.askQuestion)("What's your project Title? (press ENTER to use default: "+highlight(data.defaultAppTitle)+")",data,'inputAppTitle');}).
then(function(){data.appID="com.mycompany."+data.inputProjectName.replace(/\s+/g,'').toLowerCase();}).
then(function(){return(0,_common.askQuestion)("What's your App ID? (press ENTER to use default: "+highlight(data.appID)+")",data,'inputAppID');}).
then(function(){return(0,_common.askQuestion)("What's your Version? (press ENTER to use default: "+highlight(data.defaultVersion)+")",data,'inputVersion');}).
then(function(){return(0,_common.askQuestion)("What template to use? (press ENTER to use default: "+highlight(data.defaultTemplate)+")\n"+data.optionTemplates.asString+")",
data,'inputTemplate');}).
then(function(){return data.optionTemplates.pick(data.inputTemplate,data.defaultTemplate);}).
then(function(){return(0,_common.askQuestion)("What platforms would you like to use? (Add numbers separated by comma or leave blank for all)\n"+
data.optionPlatforms.asString,data,'inputSupportedPlatforms');}).
then(function(){return data.optionPlatforms.pick(data.inputSupportedPlatforms);}).
then(function(){return _prepareProjectOverview(c,data);}).
then(function(){return(0,_common.askQuestion)("Is All Correct? (press ENTER for yes)\n"+data.confirmString);}).
then(function(){return _generateProject(c,data);}).
then(function(){return resolve();}).
catch(function(e){return reject(e);});
});};

var _generateProject=function _generateProject(c,data){return new Promise(function(resolve,reject){
(0,_common.finishQuestion)();


var base=_path.default.resolve('.');

c.paths.projectRootFolder=_path.default.join(base,data.projectName.replace(/(\s+)/g,'_'));
c.paths.projectPackagePath=_path.default.join(c.paths.projectRootFolder,'package.json');

data.packageName=data.appTitle.replace(/\s+/g,'-').toLowerCase();

(0,_fileutils.mkdirSync)(c.paths.projectRootFolder);

checkAndCreateProjectPackage(c,data);

checkAndCreateGitignore(c);

checkAndCreateProjectConfig(c,data);

(0,_common.logSuccess)("Your project is ready! navigate to project "+
_chalk.default.white("cd "+data.projectName)+" and run "+_chalk.default.white(
'rnv run -p web')+" to see magic happen!");



resolve();
});};

var _prepareProjectOverview=function _prepareProjectOverview(c,data){return new Promise(function(resolve,reject){
data.projectName=data.inputProjectName;
data.appTitle=data.inputAppTitle||data.defaultAppTitle;
data.teamID='';
data.appID=data.inputAppID?data.inputAppID.replace(/\s+/g,'-').toLowerCase():data.appID;
data.version=data.inputVersion||data.defaultVersion;

var str=(0,_logger.printBoxStart)('🚀  ReNative Project Generator');
str+=(0,_logger.printIntoBox)('');
str+=(0,_logger.printIntoBox)("Project Name (folder): "+highlight(data.projectName),1);
str+=(0,_logger.printIntoBox)("Project Title: "+highlight(data.appTitle),1);
str+=(0,_logger.printIntoBox)("Project Version: "+highlight(data.version),1);
str+=(0,_logger.printIntoBox)("App ID: "+highlight(data.appID),1);
str+=(0,_logger.printIntoBox)("Project Template: "+highlight(data.optionTemplates.selectedOption),1);
str+=(0,_logger.printIntoBox)('');
str+=(0,_logger.printIntoBox)('Project Platforms:');
str+=(0,_logger.printArrIntoBox)(data.optionPlatforms.selectedOptions);
str+=(0,_logger.printIntoBox)('');
str+=(0,_logger.printIntoBox)('Project Structure:');
str+=(0,_logger.printIntoBox)('');
str+=(0,_logger.printIntoBox)(data.projectName);
str+=_chalk.default.gray("\u2502   \u251C\u2500\u2500 appConfigs           # Application flavour configuration files/assets  \u2502\n\u2502   \u2502   \u2514\u2500\u2500 default          # Example application flavour                     \u2502\n\u2502   \u2502       \u251C\u2500\u2500 assets       # Platform assets injected to ./platformAssets    \u2502\n\u2502   \u2502       \u251C\u2500\u2500 builds       # Platform files injected to ./platformBuilds     \u2502\n\u2502   \u2502       \u2514\u2500\u2500 config.json  # Application flavour config                      \u2502\n\u2502   \u251C\u2500\u2500 platformAssets       # Generated cross-platform assets                 \u2502\n\u2502   \u251C\u2500\u2500 platformBuilds       # Generated platform app projects                 \u2502\n\u2502   \u251C\u2500\u2500 projectConfigs       # Project configuration files/assets              \u2502\n\u2502   \u2502   \u251C\u2500\u2500 fonts            # Folder for all custom fonts                     \u2502\n\u2502   \u2502   \u251C\u2500\u2500 permissions.json # Permissions configuration                       \u2502\n\u2502   \u2502   \u2514\u2500\u2500 plugins.json     # Multi-platform Plugins configuration            \u2502\n\u2502   \u251C\u2500\u2500 src                  # Source files                                    \u2502\n\u2502   \u251C\u2500\u2500 index.*.js           # Entry files                                     \u2502\n\u2502   \u2514\u2500\u2500 rnv-config.json      # ReNative project configuration                  \u2502\n");














str+=(0,_logger.printIntoBox)('');
str+=(0,_logger.printBoxEnd)();
str+='\n';

data.confirmString=str;
resolve();
});};

var checkAndCreateProjectPackage=function checkAndCreateProjectPackage(c,data){
(0,_common.logTask)("checkAndCreateProjectPackage:"+data.packageName);var

packageName=
data.packageName,appTitle=data.appTitle,appID=data.appID,supportedPlatforms=data.supportedPlatforms;

if(!_fs.default.existsSync(c.paths.projectPackagePath)){
(0,_common.logInfo)("Looks like your package.json is missing. Let's create one for you!");

var pkgJson={};
pkgJson.name=packageName;
pkgJson.title=appTitle;
pkgJson.version=data.version;
pkgJson.dependencies={
renative:'latest'};

pkgJson.devDependencies={
rnv:c.files.rnvPackage.version};

pkgJson.devDependencies[data.optionTemplates.selectedOption]='latest';

var pkgJsonStringClean=JSON.stringify(pkgJson,null,2);

_fs.default.writeFileSync(c.paths.projectPackagePath,pkgJsonStringClean);
}
};exports.checkAndCreateProjectPackage=checkAndCreateProjectPackage;

var checkAndCreateGitignore=function checkAndCreateGitignore(c){
(0,_common.logTask)('checkAndCreateGitignore');
var ignrPath=_path.default.join(c.paths.projectRootFolder,'.gitignore');
if(!_fs.default.existsSync(ignrPath)){
(0,_common.logInfo)("Looks like your .gitignore is missing. Let's create one for you!");

(0,_fileutils.copyFileSync)(_path.default.join(c.paths.rnvHomeFolder,'supportFiles/gitignore-template'),ignrPath);
}
};exports.checkAndCreateGitignore=checkAndCreateGitignore;

var checkAndCreateProjectConfig=function checkAndCreateProjectConfig(c,data){
(0,_common.logTask)('checkAndCreateProjectConfig');var

packageName=
data.packageName,appTitle=data.appTitle,appID=data.appID,supportedPlatforms=data.supportedPlatforms;

if(!_fs.default.existsSync(c.paths.projectConfigPath)){
(0,_common.logInfo)("You're missing "+_constants.RNV_PROJECT_CONFIG_NAME+" file in your root project! Let's create one!");

var defaultProjectConfigs={
supportedPlatforms:data.optionPlatforms.selectedOptions,
template:data.optionTemplates.selectedOption,
defaultAppId:appID.toLowerCase()};


var obj=JSON.parse(_fs.default.readFileSync(_path.default.join(c.paths.rnvProjectTemplateFolder,'rnv-config.json')));

obj.defaultProjectConfigs=defaultProjectConfigs;

(0,_fileutils.writeObjectSync)(_path.default.join(c.paths.projectRootFolder,_constants.RNV_PROJECT_CONFIG_NAME),obj);
}
};

var _checkAndCreatePlatforms=function _checkAndCreatePlatforms(c,platform){return new Promise(function(resolve,reject){
(0,_common.logTask)("_checkAndCreatePlatforms:"+platform);

if(!_fs.default.existsSync(c.paths.platformBuildsFolder)){
(0,_common.logWarning)('Platforms not created yet. creating them for you...');

var newCommand=(0,_extends2.default)({},c);
newCommand.subCommand='configure';
newCommand.program={appConfig:c.defaultAppConfigId,platform:platform};

(0,_platform.default)(newCommand).
then(function(){return resolve();}).
catch(function(e){return reject(e);});

return;
}
if(platform){
var appFolder=(0,_common.getAppFolder)(c,platform);
if(!_fs.default.existsSync(appFolder)){
(0,_common.logWarning)("Platform "+platform+" not created yet. creating them for you...");

var _newCommand=(0,_extends2.default)({},c);
_newCommand.subCommand='configure';
_newCommand.program={appConfig:c.defaultAppConfigId,platform:platform};

(0,_platform.default)(_newCommand).
then(function(){return resolve();}).
catch(function(e){return reject(e);});

return;
}
}else{var
platforms=c.files.appConfigFile.platforms;
var cmds=[];
if(!platforms){
reject("Your "+_chalk.default.white(c.paths.appConfigPath)+" is missconfigured. (Maybe you have older version?). Missing "+_chalk.default.white('{ platforms: {} }')+" object at root");
return;
}

Object.keys(platforms).forEach(function(k){
if(!_fs.default.existsSync(k)){
(0,_common.logWarning)("Platform "+k+" not created yet. creating one for you...");

var _newCommand2=(0,_extends2.default)({},c);
_newCommand2.subCommand='configure';
_newCommand2.program={appConfig:c.defaultAppConfigId,platform:platform};
cmds.push((0,_platform.default)(_newCommand2));
}
});

Promise.all(cmds).
then(function(){return resolve();}).
catch(function(e){return reject(e);});

return;
}
resolve();
});};

var copyRuntimeAssets=function copyRuntimeAssets(c){return new Promise(function(resolve,reject){
(0,_common.logTask)('copyRuntimeAssets');
var aPath=_path.default.join(c.paths.platformAssetsFolder,'runtime');
var cPath=_path.default.join(c.paths.appConfigFolder,'assets/runtime');
(0,_fileutils.copyFolderContentsRecursiveSync)(cPath,aPath);


_fs.default.writeFileSync(_path.default.join(c.paths.platformAssetsFolder,_constants.RNV_APP_CONFIG_NAME),JSON.stringify(c.files.appConfigFile,null,2));


var fontsObj='export default [';

if(c.files.appConfigFile){
if(!c.files.appConfigFile.common){
reject("Your "+_chalk.default.white(c.paths.appConfigPath)+" is missconfigured. (Maybe you have older version?). Missing "+_chalk.default.white('{ common: {} }')+" object at root");
return;
}
if(_fs.default.existsSync(c.paths.fontsConfigFolder)){
_fs.default.readdirSync(c.paths.fontsConfigFolder).forEach(function(font){
if(font.includes('.ttf')||font.includes('.otf')){
var key=font.split('.')[0];var
includedFonts=c.files.appConfigFile.common.includedFonts;
if(includedFonts){
if(includedFonts.includes('*')||includedFonts.includes(key)){
if(font){
var fontSource=_path.default.join(c.paths.projectConfigFolder,'fonts',font);
if(_fs.default.existsSync(fontSource)){




fontsObj+="{\n                                            fontFamily: '"+
key+"',\n                                            file: require('../../projectConfig/fonts/"+
font+"'),\n                                        },";

}else{
(0,_common.logWarning)("Font "+_chalk.default.white(fontSource)+" doesn't exist! Skipping.");
}
}
}
}
}
});
}
}

fontsObj+='];';
_fs.default.writeFileSync(_path.default.join(c.paths.platformAssetsFolder,'runtime','fonts.js'),fontsObj);
var supportFiles=_path.default.resolve(c.paths.rnvHomeFolder,'supportFiles');
(0,_fileutils.copyFileSync)(
_path.default.resolve(supportFiles,'fontManager.js'),
_path.default.resolve(c.paths.platformAssetsFolder,'runtime','fontManager.js'));

(0,_fileutils.copyFileSync)(
_path.default.resolve(supportFiles,'fontManager.web.js'),
_path.default.resolve(c.paths.platformAssetsFolder,'runtime','fontManager.web.js'));


resolve();
});};exports.copyRuntimeAssets=copyRuntimeAssets;

var _copySharedPlatforms=function _copySharedPlatforms(c){return new Promise(function(resolve){
(0,_common.logTask)("_copySharedPlatform:"+c.platform);

if(c.platform){
(0,_fileutils.mkdirSync)(_path.default.resolve(c.paths.platformTemplatesFolders[c.platform],'_shared'));

(0,_fileutils.copyFolderContentsRecursiveSync)(
_path.default.resolve(c.paths.platformTemplatesFolders[c.platform],'_shared'),
_path.default.resolve(c.paths.platformBuildsFolder,'_shared'));

}

resolve();
});};

var _runPlugins=function _runPlugins(c,pluginsPath){return new Promise(function(resolve){
(0,_common.logTask)("_runPlugins:"+pluginsPath,_chalk.default.grey);

if(!_fs.default.existsSync(pluginsPath)){
(0,_common.logInfo)("Your project plugin folder "+_chalk.default.white(pluginsPath)+" does not exists. skipping plugin configuration");
resolve();
return;
}

_fs.default.readdirSync(pluginsPath).forEach(function(dir){
var source=_path.default.resolve(pluginsPath,dir,'overrides');
var dest=_path.default.resolve(c.paths.projectRootFolder,'node_modules',dir);

if(_fs.default.existsSync(source)){
(0,_fileutils.copyFolderContentsRecursiveSync)(source,dest,false);



}else{
(0,_common.logInfo)("Your plugin configuration has no override path "+_chalk.default.white(source)+". skipping override action");
}
});

resolve();
});};var _default=



run;exports.default=_default;