var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});Object.defineProperty(exports,"launchAppleSimulator",{enumerable:true,get:function get(){return _deviceManager.launchAppleSimulator;}});Object.defineProperty(exports,"listAppleDevices",{enumerable:true,get:function get(){return _deviceManager.listAppleDevices;}});exports.runAppleLog=exports.packageBundleForXcode=exports.archiveXcodeProject=exports.exportXcodeProject=exports.runXcodeProject=exports.configureXcodeProject=exports.copyAppleAssets=exports.runPod=exports.getAppFolderName=void 0;

var _path=_interopRequireDefault(require("path"));
var _fs=_interopRequireDefault(require("fs"));
var _chalk=_interopRequireDefault(require("chalk"));
var _child_process=_interopRequireDefault(require("child_process"));
var _exec=require("../systemTools/exec");
var _objectUtils=require("../systemTools/objectUtils");
var _platform=require("../cli/platform");
var _deviceManager=require("./apple/deviceManager");
var _common=require("../common");




















var _constants=require("../constants");
var _fileutils=require("../systemTools/fileutils");
var _pluginTools=require("../pluginTools");
var _plistParser=require("./apple/plistParser");



var _xcschemeParser=require("./apple/xcschemeParser");
var _podfileParser=require("./apple/podfileParser");
var _xcodeParser=require("./apple/xcodeParser");
var _swiftParser=require("./apple/swiftParser");

var readline=require('readline');

var checkIfCommandExists=function checkIfCommandExists(command){return new Promise(function(resolve,reject){return _child_process.default.exec("command -v "+command+" 2>/dev/null",function(error){
if(error)return reject(new Error(command+" not installed"));
return resolve();
});});};

var runPod=function runPod(command,cwd){var rejectOnFail=arguments.length>2&&arguments[2]!==undefined?arguments[2]:false;return new Promise(function(resolve,reject){
(0,_common.logTask)("runPod:"+command+":"+rejectOnFail);

if(!_fs.default.existsSync(cwd)){
if(rejectOnFail)return reject("Location "+cwd+" does not exists!");
(0,_common.logError)("Location "+cwd+" does not exists!");
return resolve();
}
return checkIfCommandExists('pod').
then(function(){return(0,_exec.executeAsync)('pod',[command],{
cwd:cwd,
evn:process.env,
stdio:'inherit'}).

then(function(){return resolve();}).
catch(function(e){
if(rejectOnFail){
(0,_common.logWarning)(e);
return reject(e);
}
(0,_common.logError)(e);
return resolve();
});}).
catch(function(err){return(0,_common.logError)(err);});
});};exports.runPod=runPod;

var copyAppleAssets=function copyAppleAssets(c,platform,appFolderName){return new Promise(function(resolve){
(0,_common.logTask)('copyAppleAssets');
if(!(0,_common.isPlatformActive)(c,platform,resolve))return;

var appFolder=(0,_common.getAppFolder)(c,platform);
var tId=(0,_common.getConfigProp)(c,platform,'teamID');

var iosPath=_path.default.join((0,_common.getAppFolder)(c,platform),appFolderName);
var sPath=_path.default.join(c.paths.appConfigFolder,"assets/"+platform);
(0,_fileutils.copyFolderContentsRecursiveSync)(sPath,iosPath);


_fs.default.writeFileSync(_path.default.join(appFolder,'main.jsbundle'),'{}');
(0,_fileutils.mkdirSync)(_path.default.join(appFolder,'assets'));
(0,_fileutils.mkdirSync)(_path.default.join(appFolder,appFolderName+"/images"));

resolve();
});};exports.copyAppleAssets=copyAppleAssets;

var runXcodeProject=function runXcodeProject(c,platform,target){return new Promise(function(resolve,reject){
(0,_common.logTask)("runXcodeProject:"+platform+":"+target);

if(target==='?'){
(0,_deviceManager.launchAppleSimulator)(c,platform,target).then(function(newTarget){
_runXcodeProject(c,platform,newTarget).
then(function(){return resolve();}).
catch(function(e){return reject(e);});
});
}else{
_runXcodeProject(c,platform,target).
then(function(){return resolve();}).
catch(function(e){return reject(e);});
}
});};exports.runXcodeProject=runXcodeProject;

var _runXcodeProject=function _runXcodeProject(c,platform,target){return new Promise(function(resolve,reject){
(0,_common.logTask)("_runXcodeProject:"+platform+":"+target);

var appPath=(0,_common.getAppFolder)(c,platform);var
device=c.program.device;
var scheme=(0,_common.getConfigProp)(c,platform,'scheme');
var runScheme=(0,_common.getConfigProp)(c,platform,'runScheme');
var bundleIsDev=(0,_common.getConfigProp)(c,platform,'bundleIsDev')===true;
var bundleAssets=(0,_common.getConfigProp)(c,platform,'bundleAssets')===true;
var p;

if(!scheme){
reject("You missing scheme in platforms."+
_chalk.default.yellow(platform)+" in your "+_chalk.default.white(
c.paths.appConfigPath)+"! Check example config for more info:  "+
_chalk.default.blue(
'https://github.com/pavjacko/renative/blob/master/appConfigs/helloWorld/config.json')+" ");


return;
}

if(device===true){
var devicesArr=(0,_deviceManager.getAppleDevices)(c,platform,false,true);
if(devicesArr.length===1){
(0,_common.logSuccess)("Found one device connected! device name: "+_chalk.default.white(devicesArr[0].name)+" udid: "+_chalk.default.white(devicesArr[0].udid));
if(devicesArr[0].udid){
p=[
'run-ios',
'--project-path',
appPath,
'--device',
'--udid',
devicesArr[0].udid,
'--scheme',
scheme,
'--configuration',
runScheme];

}else{
p=[
'run-ios',
'--project-path',
appPath,
'--device',
devicesArr[0].name,
'--scheme',
scheme,
'--configuration',
runScheme];

}
}else if(devicesArr.length>1){
var run=function run(selectedDevice){
(0,_common.logDebug)("Selected device: "+JSON.stringify(selectedDevice,null,3));
if(selectedDevice.udid){
p=[
'run-ios',
'--project-path',
appPath,
'--device',
'--udid',
selectedDevice.udid,
'--scheme',
scheme,
'--configuration',
runScheme];

}else{
p=[
'run-ios',
'--project-path',
appPath,
'--device',
selectedDevice.name,
'--scheme',
scheme,
'--configuration',
runScheme];

}

(0,_common.logDebug)("RN params: "+p);

if(bundleAssets){
(0,_common.logDebug)('Assets will be bundled');
packageBundleForXcode(c,platform,bundleIsDev).
then(function(v){return(0,_exec.executeAsync)('react-native',p);}).
then(function(){return resolve();}).
catch(function(e){return reject(e);});
}else{
(0,_exec.executeAsync)('react-native',p).
then(function(){return resolve();}).
catch(function(e){return reject(e);});
}
};

if(c.program.target){
var selectedDevice=devicesArr.find(function(d){return d.name===c.program.target;});
if(selectedDevice){
run(selectedDevice);
}else{
reject("Could not find device "+c.program.target);
}
return;
}

var devicesString='\n';
devicesArr.forEach(function(v,i){
devicesString+="-["+(i+1)+"] "+_chalk.default.white(v.name)+" | "+v.deviceIcon+" | v: "+_chalk.default.green(v.version)+" | udid: "+_chalk.default.blue(
v.udid)+(
v.isDevice?_chalk.default.red(' (device)'):'')+"\n";
});

var readlineInterface=readline.createInterface({
input:process.stdin,
output:process.stdout});

readlineInterface.question((0,_common.getQuestion)(devicesString+"\nType number of the device you want to launch"),function(v){
var selectedDevice=devicesArr[parseInt(v,10)-1];
if(selectedDevice){
run(selectedDevice);
}else{
reject("Wrong choice "+v+"! Ingoring");
}
});
return;
}else{
reject("No "+platform+" devices connected!");
return;
}
}else if(device){
p=['run-ios','--project-path',appPath,'--device',device,'--scheme',scheme,'--configuration',runScheme];
}else{
p=['run-ios','--project-path',appPath,'--simulator',target,'--scheme',scheme,'--configuration',runScheme];
}

(0,_common.logDebug)('running',p);
if(p){
var allowProvisioningUpdates=(0,_common.getConfigProp)(c,platform,'allowProvisioningUpdates',true);
if(allowProvisioningUpdates)p.push('--allowProvisioningUpdates');

if(bundleAssets){
packageBundleForXcode(c,platform,bundleIsDev).
then(function(v){return(0,_exec.executeAsync)('react-native',p);}).
then(function(){return resolve();}).
catch(function(e){return reject(e);});
}else{
(0,_exec.executeAsync)('react-native',p).
then(function(){return resolve();}).
catch(function(e){return reject(e);});
}
}else{
reject('Missing options for react-native command!');
}
});};

var archiveXcodeProject=function archiveXcodeProject(c,platform){return new Promise(function(resolve,reject){
(0,_common.logTask)("archiveXcodeProject:"+platform);

var appFolderName=getAppFolderName(c,platform);
var runScheme=(0,_common.getConfigProp)(c,platform,'runScheme','Debug');
var sdk=(0,_common.getConfigProp)(c,platform,'sdk');
if(!sdk){
sdk=platform===_constants.IOS?'iphoneos':'tvos';
}



var sdkArr=[sdk];




var appPath=(0,_common.getAppFolder)(c,platform);
var exportPath=_path.default.join(appPath,'release');

var scheme=(0,_common.getConfigProp)(c,platform,'scheme');
var allowProvisioningUpdates=(0,_common.getConfigProp)(c,platform,'allowProvisioningUpdates',true);
var ignoreLogs=(0,_common.getConfigProp)(c,platform,'ignoreLogs');
var bundleIsDev=(0,_common.getConfigProp)(c,platform,'bundleIsDev')===true;
var exportPathArchive=exportPath+"/"+scheme+".xcarchive";
var p=[
'-workspace',
appPath+"/"+appFolderName+".xcworkspace",
'-scheme',
scheme,
'-sdk'].concat(
sdkArr,[
'-configuration',
runScheme,
'archive',
'-archivePath',
exportPathArchive]);


if(allowProvisioningUpdates)p.push('-allowProvisioningUpdates');
if(ignoreLogs)p.push('-quiet');



(0,_common.logDebug)('running',p);

(0,_common.logTask)('archiveXcodeProject: STARTING xcodebuild ARCHIVE...');


_workerTimer=setInterval(_archiveLogger,30000);

if(c.files.appConfigFile.platforms[platform].runScheme==='Release'){
packageBundleForXcode(c,platform,bundleIsDev).
then(function(){return(0,_exec.executeAsync)('xcodebuild',p);}).
then(function(){
(0,_common.logSuccess)("Your Archive is located in "+_chalk.default.white(exportPath)+" .");
clearInterval(_workerTimer);
resolve();
}).
catch(function(e){
clearInterval(_workerTimer);
reject(e);
});
}else{
(0,_exec.executeAsync)('xcodebuild',p).
then(function(){
(0,_common.logSuccess)("Your Archive is located in "+_chalk.default.white(exportPath)+" .");
clearInterval(_workerTimer);
resolve();
}).
catch(function(e){
clearInterval(_workerTimer);
reject(e);
});
}
});};exports.archiveXcodeProject=archiveXcodeProject;

var _workerTimer;
var _archiveLogger=function _archiveLogger(){
console.log("ARCHIVING .... "+new Date().toLocaleString());
};

var exportXcodeProject=function exportXcodeProject(c,platform){return new Promise(function(resolve,reject){
(0,_common.logTask)("exportXcodeProject:"+platform);

var appPath=(0,_common.getAppFolder)(c,platform);
var exportPath=_path.default.join(appPath,'release');

var scheme=(0,_common.getConfigProp)(c,platform,'scheme');
var allowProvisioningUpdates=(0,_common.getConfigProp)(c,platform,'allowProvisioningUpdates',true);
var ignoreLogs=(0,_common.getConfigProp)(c,platform,'ignoreLogs');
var p=[
'-exportArchive',
'-archivePath',
exportPath+"/"+scheme+".xcarchive",
'-exportOptionsPlist',
appPath+"/exportOptions.plist",
'-exportPath',""+
exportPath];

if(allowProvisioningUpdates)p.push('-allowProvisioningUpdates');
if(ignoreLogs)p.push('-quiet');
(0,_common.logDebug)('running',p);

(0,_common.logTask)('exportXcodeProject: STARTING xcodebuild EXPORT...');

(0,_exec.executeAsync)('xcodebuild',p).
then(function(){
(0,_common.logSuccess)("Your IPA is located in "+_chalk.default.white(exportPath)+" .");
resolve();
}).
catch(function(e){return reject(e);});
});};exports.exportXcodeProject=exportXcodeProject;

var packageBundleForXcode=function packageBundleForXcode(c,platform){var isDev=arguments.length>2&&arguments[2]!==undefined?arguments[2]:false;
(0,_common.logTask)("packageBundleForXcode:"+platform);
var appFolderName=getAppFolderName(c,platform);
var args=[
'bundle',
'--platform',
'ios',
'--dev',
isDev,
'--assets-dest',"platformBuilds/"+
c.appId+"_"+platform,
'--entry-file',
c.files.appConfigFile.platforms[platform].entryFile+".js",
'--bundle-output',
(0,_common.getAppFolder)(c,platform)+"/main.jsbundle"];


if(c.program.info){
args.push('--verbose');
}

return(0,_exec.executeAsync)('react-native',args);
};exports.packageBundleForXcode=packageBundleForXcode;

var getAppFolderName=function getAppFolderName(c,platform){
var projectFolder=(0,_common.getConfigProp)(c,platform,'projectFolder');
if(projectFolder){
return projectFolder;
}
return platform===_constants.IOS?'RNVApp':'RNVAppTVOS';
};exports.getAppFolderName=getAppFolderName;



var runAppleLog=function runAppleLog(c){return new Promise(function(){
var filter=c.program.filter||'RNV';
var child=_child_process.default.execFile(
'xcrun',
['simctl','spawn','booted','log','stream','--predicate',"eventMessage contains \""+filter+"\""],
{stdio:'inherit',customFds:[0,1,2]});


child.stdout.on('data',function(data){
var d=data.toString();
if(d.toLowerCase().includes('error')){
console.log(_chalk.default.red(d));
}else if(d.toLowerCase().includes('success')){
console.log(_chalk.default.green(d));
}else{
console.log(d);
}
});
});};exports.runAppleLog=runAppleLog;

var configureXcodeProject=function configureXcodeProject(c,platform,ip,port){return new Promise(function(resolve,reject){
(0,_common.logTask)("configureXcodeProject:"+platform);var
device=c.program.device;
var bundlerIp=device?(0,_common.getIP)():'localhost';
var appFolder=(0,_common.getAppFolder)(c,platform);
var appFolderName=getAppFolderName(c,platform);
var bundleAssets=(0,_common.getConfigProp)(c,platform,'bundleAssets')===true;

c.pluginConfigiOS={
podfileInject:'',
exportOptions:'',
embeddedFonts:[],
embeddedFontSources:[],
pluginAppDelegateImports:'',
pluginAppDelegateMethods:'',
appDelegateMethods:{
application:{
didFinishLaunchingWithOptions:[],
open:[],
supportedInterfaceOrientationsFor:[],
didReceiveRemoteNotification:[],
didFailToRegisterForRemoteNotificationsWithError:[],
didReceive:[],
didRegister:[],
didRegisterForRemoteNotificationsWithDeviceToken:[]},

userNotificationCenter:{
willPresent:[]}}};





if(c.files.appConfigFile){
if(_fs.default.existsSync(c.paths.fontsConfigFolder)){
_fs.default.readdirSync(c.paths.fontsConfigFolder).forEach(function(font){
if(font.includes('.ttf')||font.includes('.otf')){
var key=font.split('.')[0];var
includedFonts=c.files.appConfigFile.common.includedFonts;
if(includedFonts&&(includedFonts.includes('*')||includedFonts.includes(key))){
var fontSource=_path.default.join(c.paths.projectConfigFolder,'fonts',font);
if(_fs.default.existsSync(fontSource)){
var fontFolder=_path.default.join(appFolder,'fonts');
(0,_fileutils.mkdirSync)(fontFolder);
var fontDest=_path.default.join(fontFolder,font);
(0,_fileutils.copyFileSync)(fontSource,fontDest);
c.pluginConfigiOS.embeddedFontSources.push(fontSource);
c.pluginConfigiOS.embeddedFonts.push(font);
}else{
(0,_common.logWarning)("Font "+_chalk.default.white(fontSource)+" doesn't exist! Skipping.");
}
}
}
});
}
}


var tId=(0,_common.getConfigProp)(c,platform,'teamID');
if(device&&(!tId||tId==='')){
(0,_common.logError)("Looks like you're missing teamID in your "+
_chalk.default.white(
c.paths.appConfigPath)+" => .platforms."+
platform+".teamID . you will not be able to build "+platform+" app for device!");

}


var forceUpdate=!_fs.default.existsSync(_path.default.join(appFolder,'Podfile.lock'))||c.program.update;
copyAppleAssets(c,platform,appFolderName).
then(function(){return(0,_common.copyBuildsFolder)(c,platform);}).
then(function(){return(0,_swiftParser.parseAppDelegate)(c,platform,appFolder,appFolderName,bundleAssets,bundlerIp,port);}).
then(function(){return(0,_plistParser.parseExportOptionsPlist)(c,platform);}).
then(function(){return(0,_xcschemeParser.parseXcscheme)(c,platform);}).
then(function(){return(0,_podfileParser.parsePodFile)(c,platform);}).
then(function(){return(0,_plistParser.parseEntitlementsPlist)(c,platform);}).
then(function(){return(0,_plistParser.parseInfoPlist)(c,platform);}).
then(function(){return runPod(forceUpdate?'update':'install',(0,_common.getAppFolder)(c,platform),true);}).
then(function(){return(0,_xcodeParser.parseXcodeProject)(c,platform);}).
then(function(){return resolve();}).
catch(function(e){
if(!c.program.update){
(0,_common.logWarning)("Looks like pod install is not enough! Let's try pod update! Error: "+e);
runPod('update',(0,_common.getAppFolder)(c,platform),true).
then(function(){return(0,_xcodeParser.parseXcodeProject)(c,platform);}).
then(function(){return resolve();}).
catch(function(err){return reject(err);});
}else{
reject(e);
}
});
});};exports.configureXcodeProject=configureXcodeProject;