var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.updateProfile=void 0;var _path=_interopRequireDefault(require("path"));
var _fs=_interopRequireDefault(require("fs"));
var _chalk=_interopRequireDefault(require("chalk"));
var _child_process=_interopRequireDefault(require("child_process"));
var _common=require("../../common");









var _exec=require("../../systemTools/exec");
var _constants=require("../../constants");

var updateProfile=function updateProfile(c){return new Promise(function(resolve,reject){var _getConfigProp;
(0,_common.logTask)('updateProfile',_chalk.default.grey);

if(c.platform!==_constants.IOS&&c.platform!==_constants.TVOS){
reject("updateProfile:platform "+c.platform+" not supported");
return;
}var

appId=
c.appId,platform=c.platform,paths=c.paths,files=c.files,program=c.program;var

scheme=program.scheme;
var id=(0,_common.getConfigProp)(c,platform,'id');
var teamID=(0,_common.getConfigProp)(c,platform,'teamID');
var pMethod=(_getConfigProp=(0,_common.getConfigProp)(c,platform,'exportOptions'))==null?void 0:_getConfigProp.method;
var runScheme=(0,_common.getConfigProp)(c,platform,'runScheme');
var provisioning;
if(pMethod==='ad-hoc')provisioning='adhoc';
if(pMethod==='development'||runScheme==='Debug')provisioning='development';

var args=[
'sigh',
'--app_identifier',
id,
'--team_id',
teamID,
'--output_path',
paths.globalConfigFolder+"/"+files.projectPackage.name+"/appConfigs/"+appId+"/certs",
'--force'];

if(process.env.APPLE_DEVELOPER_USERNAME){
args=args.concat([
'--username',
process.env.APPLE_DEVELOPER_USERNAME]);

}
if(provisioning){
args.push("--"+provisioning);
}

(0,_exec.executeAsync)('fastlane',args).
then(function(){
(0,_common.logSuccess)("Succesfully updated provisioning profile for "+appId+":"+scheme+":"+id);

resolve();
}).
catch(function(e){
(0,_common.logWarning)(e);
resolve();
});
});};exports.updateProfile=updateProfile;