var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.saveObjToPlistSync=exports.objToPlist=exports.parseInfoPlist=exports.parseEntitlementsPlist=exports.parseExportOptionsPlist=void 0;var _path=_interopRequireDefault(require("path"));
var _fs=_interopRequireDefault(require("fs"));
var _chalk=_interopRequireDefault(require("chalk"));
var _objectUtils=require("../../systemTools/objectUtils");
var _common=require("../../common");




















var _pluginTools=require("../../pluginTools");
var _apple=require("../apple");
var _fileutils=require("../../systemTools/fileutils");


var parseExportOptionsPlist=function parseExportOptionsPlist(c,platform){return new Promise(function(resolve,reject){

var tId=(0,_common.getConfigProp)(c,platform,'teamID');
var appFolder=(0,_common.getAppFolder)(c,platform);
var exportOptions=(0,_common.getConfigProp)(c,platform,'exportOptions')||{};

c.pluginConfigiOS.exportOptions=objToPlist(exportOptions);
var bPath=(0,_common.getBuildFilePath)(c,platform,'exportOptions.plist');
(0,_common.writeCleanFile)(bPath,_path.default.join(appFolder,'exportOptions.plist'),[
{pattern:'{{TEAM_ID}}',override:tId},
{pattern:'{{PLUGIN_EXPORT_OPTIONS}}',override:c.pluginConfigiOS.exportOptions}]);

resolve();
});};exports.parseExportOptionsPlist=parseExportOptionsPlist;

var parseEntitlementsPlist=function parseEntitlementsPlist(c,platform){return new Promise(function(resolve,reject){
(0,_common.logTask)("parseEntitlementsPlistSync:"+platform);

var appFolder=(0,_common.getAppFolder)(c,platform);
var appFolderName=(0,_apple.getAppFolderName)(c,platform);
var entitlementsPath=_path.default.join(appFolder,appFolderName+"/"+appFolderName+".entitlements");

var pluginsEntitlementsObj=(0,_common.getConfigProp)(c,platform,'entitlements');
if(!pluginsEntitlementsObj){
pluginsEntitlementsObj=(0,_fileutils.readObjectSync)(_path.default.join(c.paths.rnvRootFolder,'src/platformTools/apple/supportFiles/entitlements.json'));
}

saveObjToPlistSync(entitlementsPath,pluginsEntitlementsObj);
resolve();
});};exports.parseEntitlementsPlist=parseEntitlementsPlist;

var parseInfoPlist=function parseInfoPlist(c,platform){return new Promise(function(resolve,reject){
(0,_common.logTask)("parseInfoPlistSync:"+platform);

var appFolder=(0,_common.getAppFolder)(c,platform);
var appFolderName=(0,_apple.getAppFolderName)(c,platform);var _c$files$appConfigFil=
c.files.appConfigFile.platforms[platform],permissions=_c$files$appConfigFil.permissions,orientationSupport=_c$files$appConfigFil.orientationSupport,urlScheme=_c$files$appConfigFil.urlScheme,plistExtra=_c$files$appConfigFil.plistExtra;
var plistPath=_path.default.join(appFolder,appFolderName+"/Info.plist");


var plistObj=(0,_fileutils.readObjectSync)(_path.default.join(c.paths.rnvRootFolder,'src/platformTools/apple/supportFiles/info.plist.json'));
plistObj.CFBundleDisplayName=(0,_common.getAppTitle)(c,platform);
plistObj.CFBundleShortVersionString=(0,_common.getAppVersion)(c,platform);

if(c.pluginConfigiOS.embeddedFonts.length){
plistObj.UIAppFonts=c.pluginConfigiOS.embeddedFonts;
}

var pluginPermissions='';
if(permissions){
if(permissions.length&&permissions[0]==='*'){
if(c.files.permissionsConfig){
var plat=c.files.permissionsConfig.permissions[platform]?platform:'ios';
var pc=c.files.permissionsConfig.permissions[plat];
for(var v in pc){
plistObj[pc[v].key]=pc[v].desc;
}
}
}else{
permissions.forEach(function(v){
if(c.files.permissionsConfig){
var _plat=c.files.permissionsConfig.permissions[platform]?platform:'ios';
var _pc=c.files.permissionsConfig.permissions[_plat];
if(_pc[v]){
plistObj[_pc[v].key]=_pc[v].desc;
}
}
});
}
}

if(orientationSupport){
if(orientationSupport.phone){
plistObj.UISupportedInterfaceOrientations=orientationSupport.phone;
}else{
plistObj.UISupportedInterfaceOrientations=['UIInterfaceOrientationPortrait'];
}
if(orientationSupport.tab){
plistObj['UISupportedInterfaceOrientations~ipad']=orientationSupport.tab;
}else{
plistObj['UISupportedInterfaceOrientations~ipad']=['UIInterfaceOrientationPortrait'];
}
}

if(urlScheme){
plistObj.CFBundleURLTypes.push({
CFBundleTypeRole:'Editor',
CFBundleURLName:urlScheme,
CFBundleURLSchemes:[urlScheme]});

}

if(plistExtra){
plistObj=(0,_fileutils.mergeObjects)(c,plistObj,plistExtra);
}

(0,_pluginTools.parsePlugins)(c,platform,function(plugin,pluginPlat,key){
if(pluginPlat.plist){
plistObj=(0,_fileutils.mergeObjects)(c,plistObj,pluginPlat.plist);
}
});
saveObjToPlistSync(plistPath,plistObj);
resolve();
});};exports.parseInfoPlist=parseInfoPlist;

var PLIST_START="<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<!DOCTYPE plist PUBLIC \"-//Apple//DTD PLIST 1.0//EN\" \"http://www.apple.com/DTDs/PropertyList-1.0.dtd\">\n<plist version=\"1.0\">\n";



var PLIST_END='</plist>\n';

var objToPlist=function objToPlist(obj){
var output=PLIST_START;
output+=_parseObject(obj,0);
output+=PLIST_END;
return output;
};exports.objToPlist=objToPlist;

var _parseObject=function _parseObject(obj,level){
var output='';
var space='';
for(var i=0;i<level;i++){
space+='  ';
}
if((0,_objectUtils.isArray)(obj)){
output+=space+"<array>\n";
obj.forEach(function(v){
output+=_parseObject(v,level+1);
});
output+=space+"</array>\n";
}else if((0,_objectUtils.isBool)(obj)){
output+=space+"<"+obj+" />\n";
}else if((0,_objectUtils.isObject)(obj)){
output+=space+"<dict>\n";
for(var key in obj){
output+="  "+space+"<key>"+key+"</key>\n";
output+=_parseObject(obj[key],level+1);
}
output+=space+"</dict>\n";
}else if((0,_objectUtils.isString)(obj)){
output+=space+"<string>"+obj+"</string>\n";
}

return output;
};

var saveObjToPlistSync=function saveObjToPlistSync(filePath,obj){
_fs.default.writeFileSync(filePath,objToPlist(obj));
};exports.saveObjToPlistSync=saveObjToPlistSync;