var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.injectPluginSwiftSync=exports.parseAppDelegate=void 0;var _path=_interopRequireDefault(require("path"));
var _fs=_interopRequireDefault(require("fs"));
var _chalk=_interopRequireDefault(require("chalk"));
var _common=require("../../common");




















var _pluginTools=require("../../pluginTools");


VALUES={
provisioningStyle:{
allowedValues:['Automatic','Manual'],
defaultValue:'Automatic'}};



var parseAppDelegate=function parseAppDelegate(c,platform,appFolder,appFolderName){var isBundled=arguments.length>4&&arguments[4]!==undefined?arguments[4]:false;var ip=arguments.length>5&&arguments[5]!==undefined?arguments[5]:'localhost';var port=arguments.length>6&&arguments[6]!==undefined?arguments[6]:8081;return new Promise(function(resolve,reject){
(0,_common.logTask)("parseAppDelegateSync:"+platform+":"+ip+":"+port);
var appDelegate='AppDelegate.swift';

var entryFile=(0,_common.getEntryFile)(c,platform);
var appTemplateFolder=(0,_common.getAppTemplateFolder)(c,platform);var
backgroundColor=c.files.appConfigFile.platforms[platform].backgroundColor;
var tId=(0,_common.getConfigProp)(c,platform,'teamID');
var runScheme=(0,_common.getConfigProp)(c,platform,'runScheme');
var allowProvisioningUpdates=(0,_common.getConfigProp)(c,platform,'allowProvisioningUpdates',true);
var provisioningStyle=(0,_common.getConfigProp)(c,platform,'provisioningStyle','Automatic');
var bundle;
if(isBundled){
bundle="RCTBundleURLProvider.sharedSettings().jsBundleURL(forBundleRoot: \""+entryFile+"\", fallbackResource: nil)";
}else{
bundle="URL(string: \"http://"+ip+":"+port+"/"+entryFile+".bundle?platform=ios\")";
}


(0,_pluginTools.parsePlugins)(c,platform,function(plugin,pluginPlat,key){
injectPluginSwiftSync(c,pluginPlat,key,pluginPlat.package);
});


var pluginBgColor='vc.view.backgroundColor = UIColor.white';
var UI_COLORS=['black','blue','brown','clear','cyan','darkGray','gray','green','lightGray','magneta','orange','purple','red','white','yellow'];
if(backgroundColor){
if(UI_COLORS.includes(backgroundColor)){
pluginBgColor="vc.view.backgroundColor = UIColor."+backgroundColor;
}else{
(0,_common.logWarning)("Your choosen color in config.json for platform "+_chalk.default.white(platform)+" is not supported by UIColor. use one of the predefined ones: "+_chalk.default.white(UI_COLORS.join(',')));
}
}

var methods={
application:{
didFinishLaunchingWithOptions:{
isRequired:true,
func:'func application(_ application: UIApplication, didFinishLaunchingWithOptions launchOptions: [UIApplicationLaunchOptionsKey: Any]?) -> Bool {',
begin:"\n        self.window = UIWindow(frame: UIScreen.main.bounds)\n        let vc = UIViewController()\n        let v = RCTRootView(\n            bundleURL: bundleUrl,\n            moduleName: moduleName,\n            initialProperties: nil,\n            launchOptions: launchOptions)\n        vc.view = v\n        "+








pluginBgColor+"\n        v?.frame = vc.view.bounds\n        self.window?.rootViewController = vc\n        self.window?.makeKeyAndVisible()\n        UNUserNotificationCenter.current().delegate = self\n                ",





render:function render(v){return""+v;},
end:'return true'},


open:{
func:'func application(_ app: UIApplication, open url: URL, options: [UIApplicationOpenURLOptionsKey : Any] = [:]) -> Bool {',
begin:'var handled = false',
render:function render(v){return"if(!handled) { handled = "+v+" }";},
end:'return handled'},


supportedInterfaceOrientationsFor:{
func:'func application(_ application: UIApplication, supportedInterfaceOrientationsFor window: UIWindow?) -> UIInterfaceOrientationMask {',
begin:null,
render:function render(v){return"return "+v;},
end:null},


didReceiveRemoteNotification:{
func:'func application(_ application: UIApplication, didReceiveRemoteNotification userInfo: [AnyHashable : Any], fetchCompletionHandler completionHandler: @escaping (UIBackgroundFetchResult) -> Void) {',
begin:null,
render:function render(v){return""+v;},
end:null},


didFailToRegisterForRemoteNotificationsWithError:{
func:'func application(_ application: UIApplication, didFailToRegisterForRemoteNotificationsWithError error: Error) {',
begin:null,
render:function render(v){return""+v;},
end:null},


didReceive:{
func:'func application(_ application: UIApplication, didReceive notification: UILocalNotification) {',
begin:null,
render:function render(v){return""+v;},
end:null},


didRegister:{
func:'func application(_ application: UIApplication, didRegister notificationSettings: UIUserNotificationSettings) {',
begin:null,
render:function render(v){return""+v;},
end:null},


didRegisterForRemoteNotificationsWithDeviceToken:{
func:'func application(_ application: UIApplication, didRegisterForRemoteNotificationsWithDeviceToken deviceToken: Data) {',
begin:null,
render:function render(v){return""+v;},
end:null}},



userNotificationCenter:{
willPresent:{
func:'func userNotificationCenter(_ center: UNUserNotificationCenter, willPresent notification: UNNotification, withCompletionHandler completionHandler: @escaping (UNNotificationPresentationOptions) -> Void) {',
begin:null,
render:function render(v){return""+v;},
end:null}}};




var constructMethod=function constructMethod(lines,method){
var output='';
if(lines.length||method.isRequired){
output+="\n"+method.func+"\n";
if(method.begin)output+="   "+method.begin+"\n";
lines.forEach(function(v){
output+="    "+method.render(v)+"\n";
});
if(method.end)output+="   "+method.end+"\n";
output+='}\n';
}
return output;
};

for(var key in methods){
var method=methods[key];
for(var key2 in method){
var f=method[key2];
c.pluginConfigiOS.pluginAppDelegateMethods+=constructMethod(c.pluginConfigiOS.appDelegateMethods[key][key2],f);
}
}

(0,_common.writeCleanFile)(
_path.default.join((0,_common.getAppTemplateFolder)(c,platform),appFolderName,appDelegate),
_path.default.join(appFolder,appFolderName,appDelegate),
[
{pattern:'{{BUNDLE}}',override:bundle},
{pattern:'{{ENTRY_FILE}}',override:entryFile},
{pattern:'{{IP}}',override:ip},
{pattern:'{{PORT}}',override:port},
{pattern:'{{BACKGROUND_COLOR}}',override:pluginBgColor},
{
pattern:'{{APPDELEGATE_IMPORTS}}',
override:c.pluginConfigiOS.pluginAppDelegateImports},

{
pattern:'{{APPDELEGATE_METHODS}}',
override:c.pluginConfigiOS.pluginAppDelegateMethods}]);



resolve();
});};exports.parseAppDelegate=parseAppDelegate;

var injectPluginSwiftSync=function injectPluginSwiftSync(c,plugin,key,pkg){
(0,_common.logTask)("injectPluginSwiftSync:"+c.platform+":"+key,_chalk.default.grey);
if(plugin.appDelegateImports instanceof Array){
plugin.appDelegateImports.forEach(function(appDelegateImport){

(0,_common.logTask)('appDelegateImports add',_chalk.default.grey);
if(c.pluginConfigiOS.pluginAppDelegateImports.indexOf(appDelegateImport)===-1){
(0,_common.logTask)('appDelegateImports add ok',_chalk.default.grey);
c.pluginConfigiOS.pluginAppDelegateImports+="import "+appDelegateImport+"\n";
}
});
}




if(plugin.appDelegateMethods){
for(var _key in plugin.appDelegateMethods){var _loop=function _loop(
key2){
var plugArr=c.pluginConfigiOS.appDelegateMethods[_key][key2];
var plugVal=plugin.appDelegateMethods[_key][key2];
if(plugVal){
plugVal.forEach(function(v){
if(!plugArr.includes(v)){
plugArr.push(v);
}
});
}};for(var key2 in plugin.appDelegateMethods[_key]){_loop(key2);
}
}
}
};exports.injectPluginSwiftSync=injectPluginSwiftSync;