var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.runElectronDevServer=exports.exportElectron=exports.buildElectron=exports.runElectron=exports.configureElectronProject=void 0;var _regenerator=_interopRequireDefault(require("@babel/runtime/regenerator"));var _path=_interopRequireDefault(require("path"));
var _fs=_interopRequireDefault(require("fs"));
var _chalk=_interopRequireDefault(require("chalk"));
var _child_process=require("child_process");
var _platform=require("../cli/platform");
var _exec=require("../systemTools/exec");
var _common=require("../common");



























var _constants=require("../constants");
var _web=require("./web");
var _fileutils=require("../systemTools/fileutils");




var isRunningOnWindows=process.platform==='win32';

var configureElectronProject=function configureElectronProject(c,platform){return new Promise(function(resolve,reject){
(0,_common.logTask)("configureElectronProject:"+platform);



copyElectronAssets(c,platform).
then(function(){return(0,_common.copyBuildsFolder)(c,platform);}).
then(function(){return configureProject(c,platform);}).
then(function(){return resolve();}).
catch(function(e){return reject(e);});
});};exports.configureElectronProject=configureElectronProject;

var configureProject=function configureProject(c,platform){return new Promise(function(resolve,reject){
(0,_common.logTask)("configureProject:"+platform);

if(!(0,_common.isPlatformActive)(c,platform,resolve))return;

var appFolder=(0,_common.getAppFolder)(c,platform);
var templateFolder=(0,_common.getAppTemplateFolder)(c,platform);
var bundleIsDev=(0,_common.getConfigProp)(c,platform,'bundleIsDev')===true;
var bundleAssets=(0,_common.getConfigProp)(c,platform,'bundleAssets')===true;
var electronConfigPath=_path.default.join(appFolder,'electronConfig.json');
var packagePath=_path.default.join(appFolder,'package.json');
var appId=(0,_common.getAppId)(c,platform);

if(!_fs.default.existsSync(packagePath)){
(0,_common.logWarning)("Looks like your "+_chalk.default.white(platform)+" platformBuild is misconfigured!. let's repair it.");
(0,_platform.createPlatformBuild)(c,platform).
then(function(){return configureElectronProject(c,platform);}).
then(function(){return resolve(c);}).
catch(function(e){return reject(e);});
return;
}

var pkgJson=_path.default.join(templateFolder,'package.json');
var packageJson=(0,_fileutils.readObjectSync)(pkgJson);

packageJson.name=(0,_common.getAppConfigId)(c,platform)+"-"+platform;
packageJson.productName=(0,_common.getAppTitle)(c,platform)+" - "+platform;
packageJson.version=""+(0,_common.getAppVersion)(c,platform);
packageJson.description=""+(0,_common.getAppDescription)(c,platform);
packageJson.author=(0,_common.getAppAuthor)(c,platform);
packageJson.license=""+(0,_common.getAppLicense)(c,platform);
packageJson.main='./main.js';

(0,_fileutils.writeObjectSync)(packagePath,packageJson);

if(bundleAssets){
(0,_fileutils.copyFileSync)(_path.default.join(templateFolder,'_privateConfig','main.js'),_path.default.join(appFolder,'main.js'));
(0,_fileutils.copyFileSync)(
_path.default.join(templateFolder,'_privateConfig','webpack.config.js'),
_path.default.join(appFolder,'webpack.config.js'));

}else{
var ip=isRunningOnWindows?'127.0.0.1':'0.0.0.0';
(0,_common.writeCleanFile)(_path.default.join(templateFolder,'_privateConfig','main.dev.js'),_path.default.join(appFolder,'main.js'),[
{pattern:'{{DEV_SERVER}}',override:"http://"+ip+":"+c.platformDefaults[platform].defaultPort}]);

(0,_fileutils.copyFileSync)(
_path.default.join(templateFolder,'_privateConfig','webpack.config.dev.js'),
_path.default.join(appFolder,'webpack.config.js'));

}

var electronConfig={
appId:appId,
directories:{
app:appFolder,
buildResources:_path.default.join(appFolder,'resources'),
output:_path.default.join(appFolder,'build/release')}};


(0,_fileutils.writeObjectSync)(electronConfigPath,electronConfig);


resolve();
});};

var copyElectronAssets=function copyElectronAssets(c,platform){return new Promise(function(resolve){
(0,_common.logTask)("copyElectronAssets:"+platform);
if(!(0,_common.isPlatformActive)(c,platform,resolve))return;


if(platform===_constants.MACOS){
_generateICNS(c,platform).
then(function(){return resolve();}).
catch(function(e){return reject(e);});
}else{
var destPath=_path.default.join((0,_common.getAppFolder)(c,platform),'resources');
var sourcePath=_path.default.join(c.paths.appConfigFolder,"assets/"+platform+"/resources");
(0,_fileutils.copyFolderContentsRecursiveSync)(sourcePath,destPath);
resolve();
}
});};

var buildElectron=function buildElectron(c,platform){return new Promise(function(resolve,reject){
(0,_common.logTask)("buildElectron:"+platform);

var appFolder=(0,_common.getAppFolder)(c,platform);
(0,_web.buildWeb)(c,platform).
then(function(){return resolve();}).
catch(function(e){return reject(e);});
});};exports.buildElectron=buildElectron;

var exportElectron=function exportElectron(c,platform){return new Promise(function(resolve,reject){
(0,_common.logTask)("exportElectron:"+platform);

var appFolder=(0,_common.getAppFolder)(c,platform);
(0,_exec.execShellAsync)("npx electron-builder --config "+_path.default.join(appFolder,'electronConfig.json')).
then(function(){
(0,_common.logSuccess)("Your Exported App is located in "+_chalk.default.white(_path.default.join(appFolder,'build/release'))+" .");
resolve();
}).
catch(function(e){return reject(e);});
});};exports.exportElectron=exportElectron;

var runElectron=function runElectron(c,platform,port){var bundleIsDev,bundleAssets,isPortActive;return _regenerator.default.async(function runElectron$(_context){while(1){switch(_context.prev=_context.next){case 0:
(0,_common.logTask)("runElectron:"+platform);

bundleIsDev=(0,_common.getConfigProp)(c,platform,'bundleIsDev')===true;
bundleAssets=(0,_common.getConfigProp)(c,platform,'bundleAssets')===true;if(!

bundleAssets){_context.next=10;break;}_context.next=6;return _regenerator.default.awrap(
buildElectron(c,platform,bundleIsDev));case 6:_context.next=8;return _regenerator.default.awrap(
_runElectronSimulator(c,platform));case 8:_context.next=24;break;case 10:_context.next=12;return _regenerator.default.awrap(

(0,_common.checkPortInUse)(c,platform,port));case 12:isPortActive=_context.sent;if(
isPortActive){_context.next=21;break;}
(0,_common.logInfo)("Looks like your "+
_chalk.default.white(platform)+" devServer at port "+_chalk.default.white(
port)+" is not running. Starting it up for you...");_context.next=17;return _regenerator.default.awrap(


_runElectronSimulator(c,platform));case 17:_context.next=19;return _regenerator.default.awrap(
runElectronDevServer(c,platform,port));case 19:_context.next=24;break;case 21:

(0,_common.logInfo)("Looks like your "+
_chalk.default.white(platform)+" devServer at port "+_chalk.default.white(
port)+" is already running. ReNative will use it!");_context.next=24;return _regenerator.default.awrap(


_runElectronSimulator(c,platform));case 24:case"end":return _context.stop();}}});};exports.runElectron=runElectron;




var _runElectronSimulator=function _runElectronSimulator(c,platform){return new Promise(function(resolve,reject){
var appFolder=(0,_common.getAppFolder)(c,platform);
var elc=(0,_common.resolveNodeModulePath)(c,'electron/cli.js');

var child=(0,_child_process.spawn)('node',[elc,appFolder],{
detached:true,
env:process.env,
stdio:'inherit'}).

on('close',function(code){return process.exit(code);}).
on('error',function(spawnError){return console.error(spawnError);});

child.unref();
resolve();
});};

var runElectronDevServer=function runElectronDevServer(c,platform,port){return new Promise(function(resolve,reject){
(0,_common.logTask)("runElectronDevServer:"+platform);

var appFolder=(0,_common.getAppFolder)(c,platform);
var templateFolder=(0,_common.getAppTemplateFolder)(c,platform);
(0,_fileutils.copyFileSync)(
_path.default.join(templateFolder,'_privateConfig','webpack.config.dev.js'),
_path.default.join(appFolder,'webpack.config.js'));


(0,_web.runWebDevServer)(c,platform,port).
then(function(){return resolve();}).
catch(function(e){return reject(e);});
});};exports.runElectronDevServer=runElectronDevServer;

var _generateICNS=function _generateICNS(c,platform){return new Promise(function(resolve,reject){
(0,_common.logTask)("_generateICNS:"+platform);

var source=_path.default.join(c.paths.appConfigFolder,"assets/"+platform+"/AppIcon.iconset");

var dest=_path.default.join((0,_common.getAppFolder)(c,platform),'resources/icon.icns');

if(!_fs.default.existsSync(source)){
(0,_common.logWarning)("Your app config is missing "+_chalk.default.white(source)+". icon.icns will not be generated!");
resolve();
return;
}

(0,_fileutils.mkdirSync)(_path.default.join((0,_common.getAppFolder)(c,platform),'resources'));

var p=[
'--convert',
'icns',
source,
'--output',
dest];

try{
(0,_exec.executeAsync)('iconutil',p);
resolve();
}catch(e){
reject(e);
}
});};