var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.default=exports.getLocalRenativePlugin=exports.parsePlugins=exports.getMergedPlugin=void 0;var _chalk=_interopRequireDefault(require("chalk"));
var _fileutils=require("../systemTools/fileutils");
var _common=require("../common");

var getMergedPlugin=function getMergedPlugin(c,key,plugins){var noMerge=arguments.length>3&&arguments[3]!==undefined?arguments[3]:false;
var plugin=plugins[key];
var origPlugin=c.files.pluginTemplatesConfig.plugins[key];
if(typeof plugin==='string'||plugin instanceof String){
if(plugin==='source:rnv'){
return origPlugin;
}

(0,_common.logWarning)("Plugin "+key+" is not recognized RNV plugin");
return null;
}


if(origPlugin){
var mergedPlugin=(0,_fileutils.mergeObjects)(c,origPlugin,plugin);
return mergedPlugin;
}

return plugin;
};exports.getMergedPlugin=getMergedPlugin;

var parsePlugins=function parsePlugins(c,platform,pluginCallback){
(0,_common.logTask)("parsePlugins:"+platform);

if(c.files.appConfigFile&&c.files.pluginConfig){
var includedPlugins=(0,_common.getConfigProp)(c,platform,'includedPlugins',[]);
var excludedPlugins=(0,_common.getConfigProp)(c,platform,'excludedPlugins',[]);
if(includedPlugins){var
plugins=c.files.pluginConfig.plugins;
Object.keys(plugins).forEach(function(key){
if((includedPlugins.includes('*')||includedPlugins.includes(key))&&!excludedPlugins.includes(key)){
var plugin=getMergedPlugin(c,key,plugins);
if(plugin){
var pluginPlat=plugin[c.platform];
if(pluginPlat){
if(plugin['no-active']!==true&&plugin.enabled!==false&&pluginPlat.enabled!==false){
if(pluginCallback)pluginCallback(plugin,pluginPlat,key);
}else{
(0,_common.logWarning)("Plugin "+key+" is marked disabled. skipping.");
}
}
}
}
});
}else{
(0,_common.logWarning)("You haven't included any "+_chalk.default.white('{ common: { includedPlugins: [] }}')+" in your "+_chalk.default.white(c.paths.appConfigPath)+". Your app might not work correctly");
}
}
};exports.parsePlugins=parsePlugins;

var getLocalRenativePlugin=function getLocalRenativePlugin(){return{
version:'file:./packages/renative',
webpack:{
modulePaths:[],
moduleAliases:{
renative:{
projectPath:'packages/renative'}}}};};exports.getLocalRenativePlugin=getLocalRenativePlugin;var _default=







{getMergedPlugin:getMergedPlugin,parsePlugins:parsePlugins,getLocalRenativePlugin:getLocalRenativePlugin};exports.default=_default;