var _interopRequireWildcard=require("@babel/runtime/helpers/interopRequireWildcard");var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.execShellAsync=execShellAsync;exports.default=exports.commandExistsSync=exports.commandExists=exports.execCLI=exports.executeAsync=void 0;var _defineProperty2=_interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));var _extends2=_interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _path=_interopRequireDefault(require("path"));
var _shelljs=_interopRequireDefault(require("shelljs"));
var _fs=_interopRequireWildcard(require("fs"));
var _chalk=_interopRequireDefault(require("chalk"));

var _common=require("../common");function ownKeys(object,enumerableOnly){var keys=Object.keys(object);if(Object.getOwnPropertySymbols){var symbols=Object.getOwnPropertySymbols(object);if(enumerableOnly)symbols=symbols.filter(function(sym){return Object.getOwnPropertyDescriptor(object,sym).enumerable;});keys.push.apply(keys,symbols);}return keys;}function _objectSpread(target){for(var i=1;i<arguments.length;i++){var source=arguments[i]!=null?arguments[i]:{};if(i%2){ownKeys(source,true).forEach(function(key){(0,_defineProperty2.default)(target,key,source[key]);});}else if(Object.getOwnPropertyDescriptors){Object.defineProperties(target,Object.getOwnPropertyDescriptors(source));}else{ownKeys(source).forEach(function(key){Object.defineProperty(target,key,Object.getOwnPropertyDescriptor(source,key));});}}return target;}var _require=

require('child_process'),spawn=_require.spawn,exec=_require.exec,execSync=_require.execSync;

var SEPARATOR=process.platform==='win32'?';':':';
var env=(0,_extends2.default)({},process.env);
env.PATH=_path.default.resolve('./node_modules/.bin')+SEPARATOR+env.PATH;

var execCLI=function execCLI(c,cli,command){var log=arguments.length>3&&arguments[3]!==undefined?arguments[3]:console.log;return new Promise(function(resolve,reject){
log("execCLI:"+cli+":"+command);

var toBeExecuted;

if(c&&cli){
var p=c.cli[cli];

if(!_fs.default.existsSync(p)){
reject("Location of your cli "+
_chalk.default.white(p)+" does not exists. check your "+_chalk.default.white(
c.paths.globalConfigPath)+" file if you SDK path is correct");


return;
}
toBeExecuted=p+" "+command;
}else{
toBeExecuted=command;
}

(0,_common.logDebug)('ExecCLI:',toBeExecuted);

_shelljs.default.exec(toBeExecuted,{silent:true,env:process.env,stdio:[process.stdin,'pipe','pipe']},function(error,stdout){
if(error){
reject("Command "+cli+" failed: \""+_chalk.default.white(""+toBeExecuted)+"\". "+stdout.trim());
return;
}

resolve(stdout.trim());
});
});};exports.execCLI=execCLI;

var executeAsync=function executeAsync(
cmd,
args){var
opts=arguments.length>2&&arguments[2]!==undefined?arguments[2]:{};return(
new Promise(function(resolve,reject){
if(cmd==='npm'&&process.platform==='win32')cmd='npm.cmd';

var defaultOpts={

privateParams:[],
stdio:'pipe',
env:env};


var mergedOpts=_objectSpread({},defaultOpts,{},opts);

var cleanArgs='';
var hideNext=false;
var pp=(mergedOpts==null?void 0:mergedOpts.privateParams)||[];
if(args){
args.forEach(function(v){
if(hideNext){
hideNext=false;
cleanArgs+=' ***********';
}else{
cleanArgs+=" "+v;
}
if(pp.includes(v)){
hideNext=true;
}
});
}

(0,_common.logDebug)("executeAsync:"+cmd+" "+cleanArgs);

var command=spawn(cmd,args,mergedOpts);

var stdout='';
var ended=false;


command.stdout&&
command.stdout.on('data',function(output){
var outputStr=output.toString();
if(outputStr)stdout+=outputStr;
});


command.stderr&&
command.stderr.on('data',function(output){
var outputStr=output.toString();
if(outputStr)stdout+=outputStr;
});

command.on('close',function(code){
(0,_common.logDebug)("Command "+cmd+" "+cleanArgs+" exited with code "+code);
if(code!==0){
reject(new Error("process exited with code "+code+". "+stdout));
}else{
ended=true;

(0,_common.logDebug)('Execute Command:',command);
resolve(stdout);
}
});

command.on('error',function(error){
(0,_common.logDebug)("Command "+cmd+" "+cleanArgs+" errored with "+error);
reject(new Error("process errored with "+error));
});

var killChildProcess=function killChildProcess(){
if(ended)return;
(0,_common.logDebug)("Killing child process "+cmd+" "+cleanArgs);
command.kill(1);
};

process.on('exit',killChildProcess);
process.on('SIGINT',killChildProcess);
}));};exports.executeAsync=executeAsync;

function execShellAsync(command){
(0,_common.logDebug)('Exec:',command);
return new Promise(function(resolve){
_shelljs.default.exec(command,resolve);
});
}

var isUsingWindows=process.platform==='win32';

var fileNotExists=function fileNotExists(commandName,callback){
(0,_fs.access)(commandName,_fs.constants.F_OK,
function(err){
callback(!err);
});
};

var fileNotExistsSync=function fileNotExistsSync(commandName){
try{
(0,_fs.accessSync)(commandName,_fs.constants.F_OK);
return false;
}catch(e){
return true;
}
};

var localExecutable=function localExecutable(commandName,callback){
(0,_fs.access)(commandName,_fs.constants.F_OK|_fs.constants.X_OK,
function(err){
callback(null,!err);
});
};

var localExecutableSync=function localExecutableSync(commandName){
try{
(0,_fs.accessSync)(commandName,_fs.constants.F_OK|_fs.constants.X_OK);
return true;
}catch(e){
return false;
}
};

var commandExistsUnix=function commandExistsUnix(commandName,cleanedCommandName,callback){
fileNotExists(commandName,function(isFile){
if(!isFile){
exec("command -v "+cleanedCommandName+" 2>/dev/null"+(" && { echo >&1 "+

cleanedCommandName+"; exit 0; }"),
function(error,stdout){
callback(null,!!stdout);
});
return;
}

localExecutable(commandName,callback);
});
};

var commandExistsWindows=function commandExistsWindows(commandName,cleanedCommandName,callback){
if(/[\x00-\x1f<>:"\|\?\*]/.test(commandName)){
callback(null,false);
return;
}
exec("where "+cleanedCommandName,
function(error){
if(error!==null){
callback(null,false);
}else{
callback(null,true);
}
});
};

var commandExistsUnixSync=function commandExistsUnixSync(commandName,cleanedCommandName){
if(fileNotExistsSync(commandName)){
try{
var stdout=execSync("command -v "+cleanedCommandName+" 2>/dev/null"+(" && { echo >&1 "+

cleanedCommandName+"; exit 0; }"));
return!!stdout;
}catch(error){
return false;
}
}
return localExecutableSync(commandName);
};

var commandExistsWindowsSync=function commandExistsWindowsSync(commandName,cleanedCommandName){
if(/[\x00-\x1f<>:"\|\?\*]/.test(commandName)){
return false;
}
try{
var stdout=execSync("where "+cleanedCommandName,{stdio:[]});
return!!stdout;
}catch(error){
return false;
}
};

var cleanInput=function cleanInput(s){
if(/[^A-Za-z0-9_\/:=-]/.test(s)){
s="'"+s.replace(/'/g,"'\\''")+"'";
s=s.replace(/^(?:'')+/g,'').
replace(/\\'''/g,"\\'");
}
return s;
};

if(isUsingWindows){
cleanInput=function cleanInput(s){
var isPathName=/[\\]/.test(s);
if(isPathName){
var dirname="\""+_path.default.dirname(s)+"\"";
var basename="\""+_path.default.basename(s)+"\"";
return dirname+":"+basename;
}
return"\""+s+"\"";
};
}

var commandExists=function commandExists(commandName,callback){
var cleanedCommandName=cleanInput(commandName);
if(!callback&&typeof Promise!=='undefined'){
return new Promise(function(resolve,reject){
commandExists(commandName,function(error,output){
if(output){
resolve(commandName);
}else{
reject(error);
}
});
});
}
if(isUsingWindows){
commandExistsWindows(commandName,cleanedCommandName,callback);
}else{
commandExistsUnix(commandName,cleanedCommandName,callback);
}
};exports.commandExists=commandExists;

var commandExistsSync=function commandExistsSync(commandName){
var cleanedCommandName=cleanInput(commandName);
if(isUsingWindows){
return commandExistsWindowsSync(commandName,cleanedCommandName);
}
return commandExistsUnixSync(commandName,cleanedCommandName);
};exports.commandExistsSync=commandExistsSync;var _default=



{
executeAsync:executeAsync,
execShellAsync:execShellAsync,
execCLI:execCLI};exports.default=_default;